# coding=utf-8
#
#    copyright (C) 2020 Steffen Rolapp (github@rolapp.de)
#
#    This file is part of zattooHiQ
#
#    zattooHiQ is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    zattooHiQ is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with zattooHiQ.  If not, see <http://www.gnu.org/licenses/>.
#

#print 'ZattooHiq-Service started'

import xbmc, xbmcgui, xbmcaddon, datetime, time, xbmcvfs
import os, urllib.parse
#import resources.lib.main

from .library import library
from .zattooDB import ZattooDB
#from .zapisession import ZapiSession
from .tools import *

#import web_pdb;

global player

_zattooDB_ = ZattooDB()
__addon__ = xbmcaddon.Addon()
__addondir__  = xbmcvfs.translatePath( __addon__.getAddonInfo('profile') )
__addonId__=__addon__.getAddonInfo('id')

_library_=library()
localString = __addon__.getLocalizedString

accountData=_zattooDB_.zapi.get_accountData()

def script_chk(script_name):
    return xbmc.getCondVisibility('System.AddonIsEnabeled(%s)' % script_name)

def refreshProg():
    import urllib.request, urllib.parse, urllib.error
    monitor = xbmc.Monitor()
    while not monitor.abortRequested():
        if monitor.waitForAbort(600): break
        from .zattooDB import ZattooDB
        _zattooDB_ = ZattooDB()
        #update programInfo
        startTime=datetime.datetime.now()
        endTime=datetime.datetime.now()+datetime.timedelta(minutes = 120)

        try:
            getProgNextDay()
            _zattooDB_.getProgInfo(False, startTime, endTime,'all')
        except:
            pass

def recInfo():
    import urllib.request, urllib.parse, urllib.error
    from .zattooDB import ZattooDB
    _zattooDB_ = ZattooDB()
    try:
        if accountData['nonlive']['recording_number_limit'] > 0:
            resultData = _zattooDB_.zapi.exec_zapiCall('/zapi/playlist', None)
            if resultData is None: return
            for record in resultData['recordings']:
                _zattooDB_.getShowInfo(record['program_id'])
            _library_.delete_library() # add by samoth
            _library_.make_library()
    except: return
    
def start():
    profilePath = xbmcvfs.translatePath(__addon__.getAddonInfo('profile'))

    from .zattooDB import ZattooDB
    _zattooDB_ = ZattooDB()
    #_zattooDB_.zapiSession()

    VERSION = __addon__.getAddonInfo('version')
    OLDVERSION = _zattooDB_.get_version(VERSION)

    if OLDVERSION != VERSION:
    
        # reload DB
        _zattooDB_.reloadDB()
        # set Version
        _zattooDB_.set_version(VERSION)

    import urllib.request, urllib.parse, urllib.error
    #xbmc.executebuiltin('ActivateWindow(busydialognocancel)')
    #re-import ZattooDB to prevent "convert_timestamp" error
    from .zattooDB import ZattooDB
    _zattooDB_ = ZattooDB()
    _zattooDB_.cleanProg(True)

    #re-import ZattooDB to prevent "convert_timestamp" error
    from .zattooDB import ZattooDB
    _zattooDB_ = ZattooDB()
    _zattooDB_.updateChannels()

    #re-import ZattooDB to prevent "convert_timestamp" error
    from .zattooDB import ZattooDB
    _zattooDB_ = ZattooDB()
    _zattooDB_.updateProgram()

    #try:
    tomorrow = datetime.datetime.today() + datetime.timedelta(days=1)
    _zattooDB_.updateProgram(tomorrow)
    #except:pass


    startTime=datetime.datetime.now()#-datetime.timedelta(minutes = 60)
    endTime=datetime.datetime.now()+datetime.timedelta(minutes = 20)

    #re-import ZattooDB to prevent "convert_timestamp" error
    from .zattooDB import ZattooDB
    _zattooDB_ = ZattooDB()
    #xbmcgui.Dialog().notification(localString(31916), localString(30110),  __addon__.getAddonInfo('path') + '/icon.png', 3000, False)

    if __addon__.getSetting('dbonstart') == 'true':
        _zattooDB_.getProgInfo(True, startTime, endTime)
        recInfo()
    refreshProg()

def getProgNextDay():
    from .zattooDB import ZattooDB
    _zattooDB_ = ZattooDB()

    start = datetime.time(14, 0, 0)
    now = datetime.datetime.now().time()
    tomorrow = datetime.datetime.today() + datetime.timedelta(days=1)

    if now > start:
        #debug('NextDay ' + str(start) + ' - ' + str(now) + ' - ' + str(tomorrow))
        _zattooDB_.updateProgram(tomorrow)



